// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// PostTenantsReader is a Reader for the PostTenants structure.
type PostTenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostTenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostTenantsOK creates a PostTenantsOK with default headers values
func NewPostTenantsOK() *PostTenantsOK {
	return &PostTenantsOK{}
}

/*
PostTenantsOK describes a response with status code 200, with default header values.

Response with Tenant objects
*/
type PostTenantsOK struct {
	AccessControlAllowOrigin string

	Payload *members_models.TenantResponse
}

// IsSuccess returns true when this post tenants o k response has a 2xx status code
func (o *PostTenantsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post tenants o k response has a 3xx status code
func (o *PostTenantsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants o k response has a 4xx status code
func (o *PostTenantsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post tenants o k response has a 5xx status code
func (o *PostTenantsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post tenants o k response a status code equal to that given
func (o *PostTenantsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post tenants o k response
func (o *PostTenantsOK) Code() int {
	return 200
}

func (o *PostTenantsOK) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsOK  %+v", 200, o.Payload)
}

func (o *PostTenantsOK) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsOK  %+v", 200, o.Payload)
}

func (o *PostTenantsOK) GetPayload() *members_models.TenantResponse {
	return o.Payload
}

func (o *PostTenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTenantsUnauthorized creates a PostTenantsUnauthorized with default headers values
func NewPostTenantsUnauthorized() *PostTenantsUnauthorized {
	return &PostTenantsUnauthorized{}
}

/*
PostTenantsUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostTenantsUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tenants unauthorized response has a 2xx status code
func (o *PostTenantsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tenants unauthorized response has a 3xx status code
func (o *PostTenantsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants unauthorized response has a 4xx status code
func (o *PostTenantsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tenants unauthorized response has a 5xx status code
func (o *PostTenantsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post tenants unauthorized response a status code equal to that given
func (o *PostTenantsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post tenants unauthorized response
func (o *PostTenantsUnauthorized) Code() int {
	return 401
}

func (o *PostTenantsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTenantsUnauthorized) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostTenantsUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTenantsForbidden creates a PostTenantsForbidden with default headers values
func NewPostTenantsForbidden() *PostTenantsForbidden {
	return &PostTenantsForbidden{}
}

/*
PostTenantsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostTenantsForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tenants forbidden response has a 2xx status code
func (o *PostTenantsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tenants forbidden response has a 3xx status code
func (o *PostTenantsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants forbidden response has a 4xx status code
func (o *PostTenantsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tenants forbidden response has a 5xx status code
func (o *PostTenantsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post tenants forbidden response a status code equal to that given
func (o *PostTenantsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post tenants forbidden response
func (o *PostTenantsForbidden) Code() int {
	return 403
}

func (o *PostTenantsForbidden) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsForbidden  %+v", 403, o.Payload)
}

func (o *PostTenantsForbidden) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsForbidden  %+v", 403, o.Payload)
}

func (o *PostTenantsForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTenantsNotFound creates a PostTenantsNotFound with default headers values
func NewPostTenantsNotFound() *PostTenantsNotFound {
	return &PostTenantsNotFound{}
}

/*
PostTenantsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostTenantsNotFound struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tenants not found response has a 2xx status code
func (o *PostTenantsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tenants not found response has a 3xx status code
func (o *PostTenantsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants not found response has a 4xx status code
func (o *PostTenantsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tenants not found response has a 5xx status code
func (o *PostTenantsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post tenants not found response a status code equal to that given
func (o *PostTenantsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post tenants not found response
func (o *PostTenantsNotFound) Code() int {
	return 404
}

func (o *PostTenantsNotFound) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsNotFound  %+v", 404, o.Payload)
}

func (o *PostTenantsNotFound) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsNotFound  %+v", 404, o.Payload)
}

func (o *PostTenantsNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTenantsUnprocessableEntity creates a PostTenantsUnprocessableEntity with default headers values
func NewPostTenantsUnprocessableEntity() *PostTenantsUnprocessableEntity {
	return &PostTenantsUnprocessableEntity{}
}

/*
PostTenantsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostTenantsUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tenants unprocessable entity response has a 2xx status code
func (o *PostTenantsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tenants unprocessable entity response has a 3xx status code
func (o *PostTenantsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants unprocessable entity response has a 4xx status code
func (o *PostTenantsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post tenants unprocessable entity response has a 5xx status code
func (o *PostTenantsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post tenants unprocessable entity response a status code equal to that given
func (o *PostTenantsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post tenants unprocessable entity response
func (o *PostTenantsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostTenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTenantsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostTenantsUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostTenantsInternalServerError creates a PostTenantsInternalServerError with default headers values
func NewPostTenantsInternalServerError() *PostTenantsInternalServerError {
	return &PostTenantsInternalServerError{}
}

/*
PostTenantsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostTenantsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this post tenants internal server error response has a 2xx status code
func (o *PostTenantsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post tenants internal server error response has a 3xx status code
func (o *PostTenantsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post tenants internal server error response has a 4xx status code
func (o *PostTenantsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post tenants internal server error response has a 5xx status code
func (o *PostTenantsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post tenants internal server error response a status code equal to that given
func (o *PostTenantsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post tenants internal server error response
func (o *PostTenantsInternalServerError) Code() int {
	return 500
}

func (o *PostTenantsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTenantsInternalServerError) String() string {
	return fmt.Sprintf("[POST /tenants][%d] postTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostTenantsInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *PostTenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
