// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transactions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewCreateTransactionParams creates a new CreateTransactionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateTransactionParams() *CreateTransactionParams {
	return &CreateTransactionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateTransactionParamsWithTimeout creates a new CreateTransactionParams object
// with the ability to set a timeout on a request.
func NewCreateTransactionParamsWithTimeout(timeout time.Duration) *CreateTransactionParams {
	return &CreateTransactionParams{
		timeout: timeout,
	}
}

// NewCreateTransactionParamsWithContext creates a new CreateTransactionParams object
// with the ability to set a context for a request.
func NewCreateTransactionParamsWithContext(ctx context.Context) *CreateTransactionParams {
	return &CreateTransactionParams{
		Context: ctx,
	}
}

// NewCreateTransactionParamsWithHTTPClient creates a new CreateTransactionParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateTransactionParamsWithHTTPClient(client *http.Client) *CreateTransactionParams {
	return &CreateTransactionParams{
		HTTPClient: client,
	}
}

/*
CreateTransactionParams contains all the parameters to send to the API endpoint

	for the create transaction operation.

	Typically these are written to a http.Request.
*/
type CreateTransactionParams struct {

	/* TransactionRequest.

	   An array of new Transaction records
	*/
	TransactionRequest *members_models.TransactionRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create transaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateTransactionParams) WithDefaults() *CreateTransactionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create transaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateTransactionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create transaction params
func (o *CreateTransactionParams) WithTimeout(timeout time.Duration) *CreateTransactionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create transaction params
func (o *CreateTransactionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create transaction params
func (o *CreateTransactionParams) WithContext(ctx context.Context) *CreateTransactionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create transaction params
func (o *CreateTransactionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create transaction params
func (o *CreateTransactionParams) WithHTTPClient(client *http.Client) *CreateTransactionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create transaction params
func (o *CreateTransactionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTransactionRequest adds the transactionRequest to the create transaction params
func (o *CreateTransactionParams) WithTransactionRequest(transactionRequest *members_models.TransactionRequest) *CreateTransactionParams {
	o.SetTransactionRequest(transactionRequest)
	return o
}

// SetTransactionRequest adds the transactionRequest to the create transaction params
func (o *CreateTransactionParams) SetTransactionRequest(transactionRequest *members_models.TransactionRequest) {
	o.TransactionRequest = transactionRequest
}

// WriteToRequest writes these params to a swagger request
func (o *CreateTransactionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TransactionRequest != nil {
		if err := r.SetBodyParam(o.TransactionRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
